include $(TOP)/config/before.mk

CXX = /usr/local/bin/gcc
CXXLINK = /usr/local/bin/gcc
AR = ar cq
RANLIB = ranlib
CP = cp
MKDIRHIER = mkdir -p
BinPattern = %
LibPattern = lib%.a
UseLibPattern = -l%

INSTALL         = install -c
INSTLIBFLAGS    = -m 0644
INSTEXEFLAGS    = -m 0755

%.o: %.c
	$(CC) -c $(CFLAGS) -o ./$@ $<

%.o: %.cc
	$(CXX) -c $(CXXFLAGS) -o ./$@ $<

%.o: $(SRC_DIR)/%.cc
	$(CXX) -c $(CXXFLAGS) -o ./$@ $<

# OmniORB
BUILD_NAME = omniORB_260_linux

LIB_DIR = $(TOP)/lib/$(BUILD_NAME)
BIN_DIR = $(TOP)/bin/$(BUILD_NAME)

CORBA_IMPL_ROOT = /usr/local/omniORB
CORBA_INCLUDE_DIR = -I$(CORBA_IMPL_ROOT)/include \
 -I$(CORBA_IMPL_ROOT)/src/lib/omniORB2
IDL_COMPILER  = $(CORBA_IMPL_ROOT)/bin/i586_linux_2.0_glibc/omniidl2
CXXMAKEDEPEND = $(CORBA_IMPL_ROOT)/bin/i586_linux_2.0_glibc/omkdepend -D__cplusplus -D_MSC_VER
CORBA_LIBDIR = $(CORBA_IMPL_ROOT)/lib/i586_linux_2.0_glibc
CORBA_LIB = -g -lomniORB2 -lomnithread -ltcpwrapGK
CORBA_CXX_FLAGS = -g -DXSTD= -DIRMOD= -DOMNIORB
CORBA_CXX_DEFINES = -D__x86__ -D__linux__ -D__OSVERSION__=2 -DNoNanoSleep -D_REENTRANT -DPtreadDraftVersion=10
IDL_DEFINES= -DOMNIORB
STUB_HDR_SUBST = $(STUB_DIR)/%.hh
STUB_SRC_SUBST = $(STUB_DIR)/%SK.cc
STUB_OBJ_SUBST = $(STUB_DIR)/%SK.o
IDLFLAGS = -I$(TOP)/idl -h.hh -sSK.cc -a

IMPORT_LIBRARY_FLAGS = $(patsubst %,-L:%/$(LIBDIR),$(IMPORT_TREES))

define CXXExecutable
(set -x; \
 $(RM) $@; \
 x=""; \
 for i in $$libs ; do \
  x="$$x $(patsubst %,$(UseLibPattern),$$i)"; \
 done; \
 $(CXXLINK) -o $@ $(CXXLINKOPTIONS) -L$(CORBA_LIBDIR) -L$(LIB_DIR) $^ $(CORBA_LIB)  $$x; \
)
endef

define StaticLinkLibrary
(set -x; \
 $(RM) $@; \
 $(AR) $@ $^; \
 $(RANLIB) $@; \
)
endef

define InstallLibrary
(dir="$(LIB_DIR)"; \
 files="$^"; \
 for file in $$files; do \
   $(InstallFile); \
 done; \
)
endef

include $(TOP)/config/rest.mk
include $(SRC_DIR)/dir.mk
include $(TOP)/config/last.mk


