include $(TOP)/config/before.mk

CXX = CC
CXXLINK = CC
AR = CC -xar -o
RANLIB = echo
CP = cp
MKDIRHIER = mkdir -p
BinPattern = %
LibPattern = lib%.a
UseLibPattern = -l%

INSTALL         = installbsd -c
INSTLIBFLAGS    = -m 0644
INSTEXEFLAGS    = -m 0755

%.o: %.c
	$(CC) -c $(CFLAGS) -o ./$@ $<

%.o: %.cc
	$(CXX) -c $(CXXFLAGS) -o ./$@ $<

%.o: $(SRC_DIR)/%.cc
	$(CXX) -c $(CXXFLAGS) -o ./$@ $<

# OmniORB
BUILD_NAME = orbix23_sol25

LIB_DIR = $(TOP)/lib/$(BUILD_NAME)
BIN_DIR = $(TOP)/bin/$(BUILD_NAME)

OTHREAD_INC = $(TOP)/omniORB_2.6.0/include
OTHREAD_LIBDIR = $(TOP)/omniORB_2.6.0/lib/sun4_sosV_5.5

CORBA_IMPL_ROOT = /opt/iona/OrbixMT_23c02_18
CORBA_INCLUDE_DIR = -I$(CORBA_IMPL_ROOT)/inc -I../../../../../stl -I$(OTHREAD_INC)
IDL_COMPILER  = $(CORBA_IMPL_ROOT)/bin/idl
CXXMAKEDEPEND = omkdepend -D__cplusplus
CORBA_LIBDIR = "$(CORBA_IMPL_ROOT)/lib:$(OTHREAD_LIBDIR)"
CORBA_LIB = -mt -lITinimt -lDSImt -lifrmt -lsocket -lnsl -lpthread -lrwtool -lorbixmt -lomnithread
CORBA_CXX_FLAGS = -mt -DXSTD= -DIRMOD= -DORBIX -DNO_MCAST
CORBA_CXX_DEFINES = -D__sunos__ -D__sparc__ -D__OSVERSION__=5 -DSVR4 -DUsePthread -D_REENTRANT -DPthreadDraftVersion=10 -DPthreadSupportThreadPriority
IDL_DEFINES= -DORBIX
STUB_HDR_SUBST = $(STUB_DIR)/%.hh
STUB_SRC_SUBST = $(STUB_DIR)/%S.cc
STUB_OBJ_SUBST = $(STUB_DIR)/%S.o
IDLFLAGS = -I$(TOP)/idl -B

IMPORT_LIBRARY_FLAGS = $(patsubst %,-L:%/$(LIBDIR),$(IMPORT_TREES))

define CXXExecutable
(set -x; \
 $(RM) $@; \
 x=""; \
 for i in $$libs ; do \
  x="$$x $(patsubst %,$(UseLibPattern),$$i)"; \
 done; \
 $(CXXLINK) -o $@ $(CXXLINKOPTIONS) -L$(CORBA_LIBDIR) -L$(LIB_DIR) $^ $(CORBA_LIB)  $$x; \
)
endef

define StaticLinkLibrary
(set -x; \
 $(RM) $@; \
 $(AR) $@ $^; \
 $(RANLIB) $@; \
)
endef

define InstallLibrary
(dir="$(LIB_DIR)"; \
 files="$^"; \
 for file in $$files; do \
   $(InstallFile); \
 done; \
)
endef

include $(TOP)/config/rest.mk
include $(SRC_DIR)/dir.mk
include $(TOP)/config/last.mk


