include $(TOP)/config/before.mk

# Win32 (Cygwin-32)
#

CXX = clwrapper -gnuwin32
CXXLINK = linkwrapper -gnuwin32
CP = cp
AR = libwrapper -gnuwin32
MKDIRHIER = mkdir -p
BinPattern = %.exe
LibPattern = %.lib

INSTALL         = install -c
INSTLIBFLAGS    = -m 0644
INSTEXEFLAGS    = -m 0755

%.o: %.c
	$(CC) -c $(CFLAGS) -Fo./$@ $<

%.o: %.cc
	$(CXX) -c $(CXXFLAGS) -Fo./$@ $<

%.o: $(SRC_DIR)/%.cc
	$(CXX) -c $(CXXFLAGS) -Fo./$@ $<

# OmniORB
BUILD_NAME = orbix23c_260_nt40

LIB_DIR = $(TOP)/lib/$(BUILD_NAME)
BIN_DIR = $(TOP)/bin/$(BUILD_NAME)


OTHREAD_INC = d:/corba/omniORB_2.6.1/include
OTHREAD_LIBDIR = d:/corba/omniORB_2.6.1/lib/x86_win32

CORBA_IMPL_ROOT = d:/corba/Orbix23
CORBA_INCLUDE_DIR = -I$(CORBA_IMPL_ROOT)/inc -I$(OTHREAD_INC)
IDL_COMPILER  = $(CORBA_IMPL_ROOT)/bin/idl.exe
CORBA_LIBDIR = $(CORBA_IMPL_ROOT)/lib
CORBA_LIB = initsrv.lib Wsock32.LIB advapi32.lib user32.lib ITM.LIB initsrv.lib libdsi.lib omnithread2_rt.lib ifr.lib
CXXMAKEDEPEND = omkdepend -D__cplusplus -D_MSC_VER
CORBA_CXX_FLAGS = -MD -GX -nologo -DXSTD=std -DNO_MCAST
CORBA_CXX_DEFINES = -DWIN32_LEAN_AND_MEAN  -DWIN32 -DIT_EX_MACROS -DORBIX \
	-D__x86__ -D__NT__ -D__OSVERSION__=4 -D__WIN32__
IDL_DEFINES= -DORBIX -DIRMOD="::"
STUB_HDR_SUBST = $(STUB_DIR)/%.hh
STUB_SRC_SUBST = $(STUB_DIR)/%S.cc
STUB_OBJ_SUBST = $(STUB_DIR)/%S.o
IDLFLAGS = -I$(TOP)/idl -A -B -c C.cc -h .hh -s S.cc

IMPORT_LIBRARY_FLAGS = $(patsubst %,-libpath:%/$(LIBDIR),$(IMPORT_TREES))

define CXXExecutable
(set -x; \
 $(RM) $@; \
 x=""; \
 for i in $$libs ; do \
  x="$$x $(patsubst %,$(LibPattern),$$i)"; \
 done; \
 $(CXXLINK) -out:$@ $(CXXLINKOPTIONS) -libpath:$(CORBA_LIBDIR) -libpath:$(OTHREAD_LIBDIR) -libpath:$(LIB_DIR) $^ $(CORBA_LIB)  $$x; \
)
endef

define StaticLinkLibrary
(set -x; \
 $(RM) $@; \
 $(AR) $@ $^; \
)
endef

define InstallLibrary
(dir="$(LIB_DIR)"; \
 files="$^"; \
 for file in $$files; do \
   $(InstallFile); \
 done; \
)
endef

include $(TOP)/config/rest.mk
include $(SRC_DIR)/dir.mk
include $(TOP)/config/last.mk

