// $Id: OORB_DSI.cc,v 1.3 1999/05/04 19:12:13 mencnar Exp $
//
// $Source: /home/iris/mencnar/ec/CVS/src/cc/OORB_DSI.cc,v $
//
// $Log: OORB_DSI.cc,v $
// Revision 1.3  1999/05/04 19:12:13  mencnar
// Trace messages redirected to a trace object
// Fixed constructing of a pull interface Interface Repository ID
//
// Revision 1.2  1999/02/24 12:07:55  mencnar
// *** empty log message ***
//
//

#include "echelp.hh"
#include "ec_dsi.hh"
#include "trace.hh"

#ifdef OMNIORB

// omniORB specific file
//
#include <omniORB2/CORBA.h>
#include <tcParseEngine.h>
#include <iostream.h>

extern void oorb_fill( CORBA::ULong malign, MemBufferedStream &val);
extern void oorb_marshal( CORBA::Any &v, MemBufferedStream &nbs);

class OORB_DSI : public virtual omniObject, 
		 public virtual CORBA::Object,
		 public EC_DSI 
{
  ECHelper::TypedInterface ti;
  EC_Dispatcher &ecdisp;
  int is_pull;
  CORBA::String_var intfname;

public:
  OORB_DSI( ECHelper::TypedInterface &_ti,
	    int _is_pull,
	    EC_Dispatcher &_ecdisp);
  virtual ~OORB_DSI() {
    ecdisp.ec_dsi_disposed();
  }
  virtual void *_widenFromTheMostDerivedIntf(const char *repoId,
					     CORBA::Boolean is_cxx_type_id=0);
  virtual CORBA::Boolean dispatch(GIOP_S &s,
				  const char *op,
				  CORBA::Boolean response);

  // EC_DSI interface
  virtual CORBA::Object_ptr get_object();
};

OORB_DSI::
OORB_DSI( ECHelper::TypedInterface &_ti,
	  int _is_pull,
	  EC_Dispatcher &_ecdisp) :
  ti( _ti),
  ecdisp( _ecdisp),
  is_pull( _is_pull)
{
  const char *prefix= (is_pull ? "Pull" : "");
  intfname= 
    CORBA::string_alloc( strlen(ti.id)+strlen(prefix)+1);
  if (is_pull) {
    const char *p= strrchr( ti.id, '/');
    if (!p) p= strchr( ti.id, ':');
    if (p) {
      int len= (p - (const char *) ti.id)+1;
      strncpy( intfname, ti.id, len);
      ((char*) intfname)[len]= '\0';
      strcat( intfname, prefix);
      strcat( intfname, p+1);
    }
    else {
      strcpy( intfname, "");
      // an ESIOP or a custom repository ID ?
      //
    }
  }
  else strcpy( intfname, ti.id);

  if (!is_proxy())
    omniObject::PR_IRRepositoryId( intfname);
  this->PR_setobj(this);

  CORBA::BOA::getBOA()->obj_is_ready(this);
}

CORBA::Object_ptr OORB_DSI::
get_object() {
  return CORBA::Object::_duplicate(this);
}

void * OORB_DSI::
_widenFromTheMostDerivedIntf(const char *repoId,
			     CORBA::Boolean is_cxx_type_id) {
  if (is_cxx_type_id) return 0;
  if (!repoId)
    return (void *)((CORBA::Object_ptr)this);
  if (strcmp(intfname,repoId) == 0)
    return (void *)this;
  else {
    return 0;
  }
}

CORBA::Boolean OORB_DSI::
dispatch(GIOP_S &_0RL_s,
	 const char *_0RL_op,
	 CORBA::Boolean _0RL_response_expected)
{
  trace.start(800) << "dispatch " << _0RL_op << '\n';
  for (CORBA::ULong opi=0; opi<ti.ops.length(); opi++) {
    CORBA::Boolean is_try_pull= 0;

    if (is_pull) {
      if (strncmp(_0RL_op,"pull_",strlen("pull_"))) {
	_0RL_op+= strlen("pull_");
      }
      else if (strncmp(_0RL_op,"try_",strlen("try_"))) {
	_0RL_op+= strlen("try_");
	is_try_pull= 1;
      }
      else return 0;
    }    

    if (strcmp(_0RL_op,(const char *) ti.ops[opi].name) == 0) {
      if (is_pull) {
	// all paramters are defined as OUT
	
	_0RL_s.RequestReceived();

	ECHelper::SeqAny params;
	params.length( ti.ops[opi].parameter_types.length());
	CORBA::Boolean ret= ecdisp.ec_dispatch( this, 
						is_try_pull, 
						_0RL_op, params);
	if (_0RL_response_expected) {
	  CORBA::ULong malign = 
	    (_0RL_s.WrMessageAlreadyWritten()+
	     GIOP_S::ReplyHeaderSize()) % 8;

	  MemBufferedStream mbs;
	  oorb_fill( malign, mbs);
	  if (is_try_pull) ret >>= mbs;
	  for (int i=0; i<params.length(); i++)
	    oorb_marshal( params[i], mbs);
	  CORBA::ULong _0RL_msgsize= mbs.alreadyWritten()-malign+
	    GIOP_S::ReplyHeaderSize();
	  trace.start(800) << "msgsize " << (int) _0RL_msgsize << '\n';

	  _0RL_s.InitialiseReply(GIOP::NO_EXCEPTION,
				 (CORBA::ULong)_0RL_msgsize);
	  _0RL_s.put_char_array((_CORBA_Char*) (omni::ptr_arith_t) mbs.data() +
				(omni::ptr_arith_t) malign, 
				mbs.alreadyWritten() - malign); 
	  trace.start(800) << "out paramters put into array" << '\n';

	  _0RL_s.ReplyCompleted();
	}
	return 1;	
      }
      else {
	// all paramters are defined as IN
	
	ECHelper::SeqAny params;
	params.length( ti.ops[opi].parameter_types.length());
	
	for (CORBA::ULong i=0; i<params.length(); i++) {
	  trace.start(800) << "Parse parameter " << (unsigned long) i << '\n';
	  MemBufferedStream mbs;
	  ti.ops[opi].parameter_types[i] >>= mbs;
	  tcParseEngine tcEngine(ti.ops[opi].parameter_types[i],&_0RL_s);
	  tcEngine.parse( mbs);
	  CORBA::Any val;
	  params[i] <<= mbs;
	}
	
	_0RL_s.RequestReceived();
	
	// call implementation method
	(void) ecdisp.ec_dispatch( this, ti.ops[opi].twoway, _0RL_op, params);
	
	if (_0RL_response_expected) {
	  size_t _0RL_msgsize = (size_t) GIOP_S::ReplyHeaderSize();
	  _0RL_s.InitialiseReply(GIOP::NO_EXCEPTION,
				 (CORBA::ULong)_0RL_msgsize);
	  _0RL_s.ReplyCompleted();
	}
	return 1;
      }
    }
  }
  return 0;
}

class OMNIORB_EC_DSI_Factory : public EC_DSI_Factory {
  EC_DSI * create_ec_dsi( ECHelper::TypedInterface &_ti,
			  int _is_pull,
			  EC_Dispatcher &_ecdisp) {
    return new OORB_DSI( _ti, _is_pull, _ecdisp);
  }
};

EC_DSI_Factory *default_ec_dsi_factory= new OMNIORB_EC_DSI_Factory();


#endif

//
