// $Id: ORBX_DII.cc,v 1.2 1999/05/04 19:13:28 mencnar Exp $
//
// $Source: /home/iris/mencnar/ec/CVS/src/cc/ORBX_DII.cc,v $
//
// $Log: ORBX_DII.cc,v $
// Revision 1.2  1999/05/04 19:13:28  mencnar
// A minor change to confirm to changed interface EC_DSI
//
// Revision 1.1  1999/02/24 13:01:51  mencnar
// *** empty log message ***
//
//

#ifdef ORBIX

#include "echelp.hh"
#include "ec_dii.hh"
#include <iostream.h>
#include <stdio.h>

class ORBX_DII : public EC_DII
{
  CORBA::Object_var obj;
  ECHelper::TypedInterface ti;

  CORBA::ULong find_operation_index( const char *name, const char *prefix);
public:
  ORBX_DII( CORBA::Object_ptr _obj,
	    ECHelper::TypedInterface &_ti);  
  virtual void send ( const char *operation_name, 
		      ECHelper::SeqAny &params );

  virtual void send_pull( const char *operation_name, 
			  ECHelper::SeqAny &params) {}

  virtual CORBA::Boolean send_try_pull( const char *operation_name,
					ECHelper::SeqAny &params) { return 0; }
};

ORBX_DII::
ORBX_DII( CORBA::Object_ptr _obj,
	  ECHelper::TypedInterface &_ti) :
  obj( CORBA::Object::_duplicate(_obj)),
  ti( _ti) {
}

void ORBX_DII::
send ( const char *operation_name, 
       ECHelper::SeqAny &params ) {

  CORBA::NamedValue_ptr result;
  CORBA::Any_ptr        resultAny;
  
  cerr << "---creating request" << endl;
  CORBA::Request_var r=  CORBA::Request:: IT_create (obj);
  cerr << "request created" << endl;
  r->setOperation( operation_name);
  cerr << "operation set" << endl;
  CORBA::NVList_ptr oper_list= r->arguments();
  cerr << "got arguments" << endl;
  CORBA::Flags fl;
  fl.setArgDef( CORBA::ARG_IN);
  for (CORBA::ULong i=0; i<params.length(); i++) {    
    cerr << "Parameter " << (unsigned long) i << endl;
    char buf[10];
    sprintf(buf,"P%ul",(unsigned long) i);
    r->add_arg( buf, *(params[i].type()), (void *) params[i].value(),
		i, fl);
    cerr << "add_arg succeeded" << endl;
  }
  r->set_return_type(CORBA::_tc_void);
   // Execute the request
  try {
    cerr << "--sent oneway" << endl;
    r->invoke();
    cerr << "sent oneway" << endl;
    CORBA::Environment_ptr env = r->env();
    if ( env->exception() )  {
      cout << "Exception occurred: " << *env->exception() << endl;
    }
  }
  catch (CORBA::Exception &ex) {
    cerr << ex << endl;
    cerr << __FILE__ << ' ' << __LINE__ << endl;
  }
}

class ORBIX_EC_DII_Factory : public EC_DII_Factory {
  virtual EC_DII * create_ec_dii( CORBA::Object_ptr obj,
				  ECHelper::TypedInterface &_ti ) {
    return new ORBX_DII( obj, _ti);
  }
  virtual void marshal(class McastSource &,struct ECMcast::Data &) {}
  virtual void unmarshal(class McastSink &,struct ECMcast::Data &) {}
  
};

EC_DII_Factory *default_ec_dii_factory= new ORBIX_EC_DII_Factory();

#endif // ORBIX

//
