// $Id: utils.hh,v 1.2 1999/01/09 14:27:23 mencda Exp $
//
// $Source: /home/mencda/CVSROOT/ec/src/hh/utils.hh,v $
//
// $Log: utils.hh,v $
// Revision 1.2  1999/01/09 14:27:23  mencda
// *** empty log message ***
//
// Revision 1.1.1.1  1998/12/13 23:27:16  mencda
// Imported sources
//
// Revision 1.1  1998/11/03 18:06:56  mencda
// Initial revision
//
//

#ifndef __utils_hh__
#define __utils_hh__

#define DISABLE_COPY_AND_ASSIGN(type) \
private: \
  type ( const type &); \
  type & operator = ( const type &);


template <class base>
class var {
  base *ptr;
public:
  var<base>() : ptr(NULL) {}
  var<base>( const var<base> &src) :
    ptr( src.ptr ? new base(*(src.ptr)) : NULL) {}
  var<base>( base *src) :  // assume ownership
    ptr( src) {}

  var<base> & operator = ( const var<base> &src) {
    delete ptr;
    ptr= src.ptr ? new base(*(src.ptr)) : NULL;
    return *this;
  }

  var<base> & operator = ( base *src) {  // assume ownership
    delete ptr;
    ptr= src;
  }

  ~var() {
    delete ptr;
  }
};


template <class base>
class myauto_ptr {
  base *ptr;
public:
  myauto_ptr<base>( base &src) :  // assume ownership
    ptr( &src) {}

  base * operator->() { return ptr; }
  base & operator*() { return *ptr; }

  ~myauto_ptr() {
    delete ptr;
  }
private:
  myauto_ptr<base>( const myauto_ptr<base> &src); // disabled
  //  auto_ptr<base> & operator = ( const audo_ptr<base> &src); // disabled
};


#endif

//
