
//Title:        Event Channel Manager
//Version:      0.1
//Copyright:    Copyright (c) 1999
//Author:       Daniel Mencnarowski

package pl.edu.agh.ics.mev;

import java.awt.*;
import com.sun.java.swing.*;
import java.awt.event.*;

public class Configure extends JDialog {
  JPanel panel1 = new JPanel();

  ConfigSet configSet;
  JTabbedPane jTabbedPane1 = new JTabbedPane();
  JPanel jPanel1 = new JPanel();
  BorderLayout borderLayout1 = new BorderLayout();
  JPanel jPanel2 = new JPanel();
  FlowLayout flowLayout1 = new FlowLayout();
  JButton jButton1 = new JButton();
  ButtonGroup NSGroup= new ButtonGroup();
  ButtonGroup IRGroup= new ButtonGroup();
  GridBagLayout gridBagLayout1 = new GridBagLayout();
  JRadioButton RBNS_RIS = new JRadioButton();
  JRadioButton RBNS_URL = new JRadioButton();
  JRadioButton RBNS_IOR = new JRadioButton();
  JTextField NS_URL = new JTextField();
  JTextField NS_IOR = new JTextField();
  JPanel jPanel3 = new JPanel();
  JButton BAccept_NS_URL = new JButton();
  JButton BAccept_NS_IOR = new JButton();
  GridBagLayout gridBagLayout2 = new GridBagLayout();
  JRadioButton RBIR_RIS = new JRadioButton();
  JRadioButton RBIR_URL = new JRadioButton();
  JRadioButton RBIR_IOR = new JRadioButton();
  JRadioButton RBIR_NS = new JRadioButton();
  JTextField IR_IOR = new JTextField();
  JTextField IR_URL = new JTextField();
  JTextField IR_NS = new JTextField();
  JButton BAccept_IR_URL = new JButton();
  JButton BAccept_IR_IOR = new JButton();
  JButton BAccept_IR_NS = new JButton();

  private Configure(Frame frame, String title, boolean modal) {
    super(frame, title, modal);
    try  {
      jbInit();
      pack();
    }
    catch (Exception ex) {
      ex.printStackTrace();
    }
  }


  public Configure( ConfigSet cs) {
    this(null, "Configure", true);
    configSet= cs;
    NS_URL.setEnabled(false);
    BAccept_NS_URL.setEnabled(false);
    NS_IOR.setEnabled(false);
    BAccept_NS_IOR.setEnabled(false);
    switch (cs.NSResolveType) {
      case ConfigSet.InitRef_resolve:
        RBNS_RIS.setSelected(true);
        break;
      case ConfigSet.InitRef_URL:
        RBNS_URL.setSelected(true);
        NS_URL.setEnabled(true);
        BAccept_NS_URL.setEnabled(true);
        NS_URL.setText( cs.NSResolve);
        break;
      case ConfigSet.InitRef_IOR:
        RBNS_IOR.setSelected(true);
        NS_IOR.setEnabled(true);
        BAccept_NS_IOR.setEnabled(true);
        NS_IOR.setText( cs.NSResolve);
        break;
    }
    switch (cs.IRResolveType) {
      case ConfigSet.InitRef_resolve:
        RBIR_RIS.setSelected(true);
        break;
      case ConfigSet.InitRef_URL:
        RBIR_URL.setSelected(true);
        BAccept_IR_URL.setEnabled(true);
        IR_URL.setText( cs.IRResolve);
        break;
      case ConfigSet.InitRef_IOR:
        RBIR_IOR.setSelected(true);
        BAccept_IR_IOR.setEnabled(true);
        IR_IOR.setText( cs.IRResolve);
        break;
      case ConfigSet.InitRef_NS:
        RBIR_NS.setSelected(true);
        BAccept_IR_NS.setEnabled(true);
        IR_NS.setText( cs.IRResolve);
        break;
    }
  }

  void jbInit() throws Exception {
    panel1.setLayout(borderLayout1);
    jPanel2.setLayout(flowLayout1);
    jPanel1.setLayout(gridBagLayout1);
    jButton1.setText("jButton1");
    jButton1.setLabel("OK");
    RBNS_RIS.setText("jRadioButton1");
    RBNS_RIS.setLabel("resolve_initial_references");
    RBNS_RIS.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        RBNS_RIS_actionPerformed(e);
      }
    });
    RBNS_URL.setText("jRadioButton2");
    RBNS_URL.setLabel("URL with an IOR");
    RBNS_URL.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        RBNS_URL_actionPerformed(e);
      }
    });
    RBNS_IOR.setText("jRadioButton3");
    RBNS_IOR.setLabel("IOR here");
    NS_URL.setColumns(20);
    RBNS_IOR.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        RBNS_IOR_actionPerformed(e);
      }
    });
    jPanel3.setLayout(gridBagLayout2);
    BAccept_NS_URL.setText("jButton3");
    BAccept_NS_URL.setLabel("Accept");
    BAccept_NS_URL.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        BAccept_NS_URL_actionPerformed(e);
      }
    });
    BAccept_NS_IOR.setText("jButton2");
    BAccept_NS_IOR.setActionCommand("acceptNSIOR");
    BAccept_NS_IOR.setLabel("Accept");
    BAccept_NS_IOR.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        BAccept_NS_IOR_actionPerformed(e);
      }
    });
    RBIR_RIS.setText("jRadioButton1");
    RBIR_RIS.setLabel("resolve_initial_references");
    RBIR_URL.setText("jRadioButton2");
    RBIR_URL.setLabel("URL with an IOR");
    RBIR_IOR.setText("jRadioButton3");
    RBIR_IOR.setLabel("IOR here");
    RBIR_NS.setText("jRadioButton4");
    RBIR_NS.setLabel("NS resolve");
    BAccept_IR_URL.setText("Accept");
    BAccept_IR_URL.setLabel("Accept");
    BAccept_IR_IOR.setText("Accept");
    BAccept_IR_NS.setText("Accept");
    NSGroup.add(RBNS_RIS);
    NSGroup.add(RBNS_URL);
    NSGroup.add(RBNS_IOR);
    IRGroup.add(RBIR_RIS);
    IRGroup.add(RBIR_URL);
    IRGroup.add(RBIR_IOR);
    IRGroup.add(RBIR_NS);
    jButton1.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        acceptAction(e);
      }
    });
    getContentPane().add(panel1);
    panel1.add(jTabbedPane1, BorderLayout.CENTER);
    jTabbedPane1.addTab("Naming Service", jPanel1);
    jPanel1.add(RBNS_RIS, new GridBagConstraints2(0, 0, 1, 1, 0.0, 1.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 0, 0, 0), 0, 0));
    jPanel1.add(RBNS_URL, new GridBagConstraints2(0, 1, 1, 1, 0.0, 1.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 0, 0, 0), 0, -26));
    jPanel1.add(RBNS_IOR, new GridBagConstraints2(0, 2, 1, 1, 0.0, 1.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 0, 0, 0), 0, 0));
    jPanel1.add(NS_URL, new GridBagConstraints2(1, 1, 1, 1, 1.0, 0.0
            ,GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 0, 0));
    jPanel1.add(NS_IOR, new GridBagConstraints2(1, 2, 1, 1, 1.0, 1.0
            ,GridBagConstraints.WEST, GridBagConstraints.BOTH, new Insets(0, 0, 0, 0), 0, 0));
    jPanel1.add(BAccept_NS_URL, new GridBagConstraints2(2, 1, 2, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    jPanel1.add(BAccept_NS_IOR, new GridBagConstraints2(2, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    jTabbedPane1.addTab("Interface Repository", jPanel3);
    jPanel3.add(RBIR_RIS, new GridBagConstraints2(0, 0, 1, 1, 0.0, 1.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    jPanel3.add(RBIR_URL, new GridBagConstraints2(0, 1, 1, 1, 0.0, 1.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    jPanel3.add(RBIR_IOR, new GridBagConstraints2(0, 2, 1, 1, 0.0, 1.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    jPanel3.add(RBIR_NS, new GridBagConstraints2(0, 3, 1, 1, 0.0, 1.0
            ,GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    jPanel3.add(IR_URL, new GridBagConstraints2(1, 1, 1, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 0, 0));
    jPanel3.add(IR_IOR, new GridBagConstraints2(1, 2, 1, 1, 1.0, 1.0
            ,GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(0, 0, 0, 0), 0, 0));
    jPanel3.add(IR_NS, new GridBagConstraints2(1, 3, 1, 1, 1.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 0, 0));
    jPanel3.add(BAccept_IR_URL, new GridBagConstraints2(2, 1, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    jPanel3.add(BAccept_IR_IOR, new GridBagConstraints2(2, 2, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    jPanel3.add(BAccept_IR_NS, new GridBagConstraints2(2, 3, 1, 1, 0.0, 0.0
            ,GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
    panel1.add(jPanel2, BorderLayout.SOUTH);
    jPanel2.add(jButton1, null);
  }

  void acceptAction(ActionEvent e) {
    setVisible(false);
  }

  void BAccept_NS_IOR_actionPerformed(ActionEvent e) {
    configSet.NSResolve= NS_IOR.getText();
    try {
      configSet.resolveNS();
    }
    catch (Exception ex) {
      JOptionPane.showMessageDialog(this, ex, "Error", JOptionPane.ERROR_MESSAGE);
    }
  }

  void RBNS_IOR_actionPerformed(ActionEvent e) {
    configSet.NSResolveType= ConfigSet.InitRef_IOR;
    NS_URL.setEnabled(false);
    BAccept_NS_URL.setEnabled(false);
    NS_IOR.setEnabled(true);
    BAccept_NS_IOR.setEnabled(true);
  }

  void RBNS_RIS_actionPerformed(ActionEvent e) {
    configSet.NSResolveType= ConfigSet.InitRef_resolve;
    NS_URL.setEnabled(false);
    BAccept_NS_URL.setEnabled(false);
    NS_IOR.setEnabled(false);
    BAccept_NS_IOR.setEnabled(false);
    try {
      configSet.resolveNS();
    }
    catch (Exception ex) {
      JOptionPane.showMessageDialog(this, ex, "Error", JOptionPane.ERROR_MESSAGE);
    }
  }

  void RBNS_URL_actionPerformed(ActionEvent e) {
    configSet.NSResolveType= ConfigSet.InitRef_URL;
    NS_URL.setEnabled(true);
    BAccept_NS_URL.setEnabled(true);
    NS_IOR.setEnabled(false);
    BAccept_NS_IOR.setEnabled(false);
  }

  void BAccept_NS_URL_actionPerformed(ActionEvent e) {
    configSet.NSResolve= NS_URL.getText();
    try {
      configSet.resolveNS();
    }
    catch (Exception ex) {
      JOptionPane.showMessageDialog(this, ex, "Error", JOptionPane.ERROR_MESSAGE);
      ex.printStackTrace();
    }
  }

}

